# Quickstart for Package Users

This document provides a quickstart guide for users wanting to utilize published F Prime packages in their projects.

## Project initialization

First, ensure that you have `fppm` [installed](../README.md), and that your current working directory is the root of an F Prime project. Initialize this project with:

```bash
fppm init
```

Ensure that, if your project does not have the [subtopology autocoder](https://github.com/mosa11aei/fprime-subtopology-tool) that you opt into installing it. It is crucial to utilizing packages with subtopologies. You must follow the README in that tool to finalize the installation of the tool.

Now that your project is initialized with a `project.yaml`, this file can be version controlled, and you can use:

```bash
fppm install --project
```

in the future to install all packages associated with a project.

## Package installation

To install a package, you first need to add the *registry* that hosts the package to your `project.yaml` file. You can do so using:

```bash
fppm registries --add <url or path to registry.yaml>

# verify that the registry was added correctly -- a good practice
fppm registries --verify
```

> Note that this defaults to using `./project.yaml`. But, you can configure it to use a different path by using the `--project-yaml-path your/path/to/project.yaml` flag.

Once the registry has been added to your project, you can install it with knowing the shortname of the package. The registry owner should provide this to you.

```bash
fppm install --package namespace/PackageName
```

## Package configuration

To configure the package you installed, you can generate "fillables" (yaml templates) for the [config objects](./ConfigObjects.md) the package provides. To do so, run:

```bash
fppm config --generate <PackageShortname>
```

This will generate a folder in the current working directory that contains yaml files that correspond to the configuration variables in the config objects. When you've filled the files, output files can be generated by running:

```bash
fppm config --apply <PackageShortname>
```

The output files can then be placed accordingly in your project, as spec-ed by the package developer.

## Package utilization

This is up to the package developer to provide. All tool-based initialization has been accomplished to this point. Review the package design document (pdd) that the developer provides, as well as any other design documents.
